#! /usr/bin/perl
#
# wanha - your pesky URL-guardian for IRC
# Copyright (C) 2006 Tommi Saviranta  <wnd@iki.fi>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


use strict;
use warnings FATAL => 'all';
use diagnostics;

require "dbops.pl";
require "html.pl";
require "http.pl";
require "url.pl";



&main();
exit(0);


sub main
{
	my $search = &HTTP::get("s", undef);

	defined($search) || &redir(&URL::chan(-1));

	# Assume non-'#'-starting users
	if (! ($search =~ /^#/ || $search =~ /^!/ || $search =~ /^&/)) {
		my $user = &DBOps::get_nick_id($search);
		defined($user) && &redir(&URL::user($user));

		# Assume channel name without a '#' if no nick was found
		$search = "#$search";
	}

	my $chan = &DBOps::get_chan_id($search);
	defined($chan) || &redir(&URL::chan(-1));
	&redir(&URL::chan($chan));
}


# 0: url
sub redir
{
	my ($url) = @_;
	my $location = &Conf::base_url() . "/";
	$location =~ s/\/\//\//g;
	$url = "chan.pl" if (! defined($location));
	$location = "$location$url";
	&HTTP::redirect($location);
	&HTML::print_header($location);
	print <<EOF;
<p>
Go to <a href="$location">$location</a>.
</p>

EOF
	&HTML::print_footer();
	exit(0);
}
