# wanha - your pesky URL-guardian for IRC
# Copyright (C) 2006 Tommi Saviranta  <wnd@iki.fi>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


package URL;

use strict;
use warnings FATAL => 'all';
use diagnostics;

require "config.pl";



# 0: chan id
# 1: n
# 2: seek
sub chan
{
	my ($chan_id, $n, $seek) = @_;
	my $r;

	if ($chan_id == -1) {
		return "chan.pl";
	}

	if (&Conf::rewrite() == 1) {
		$r = "chan-$chan_id";
		if (defined($n)) {
			$r .= "-$n";
			$r .= "-$seek" if (defined($seek));
		}
	} else {
		$r = "chan.pl?chan=$chan_id";
		if (defined($n)) {
			$r .= "&amp;n=$n";
			$r .= "&amp;seek=$seek" if (defined($seek));
		}
	}

	return $r;
}


# 0: chan
sub chanstat
{
	my ($chan_id) = @_;

	if (&Conf::rewrite() == 1) {
		return "chanstat-$chan_id";
	} else {
		return "chanstat.pl?chan=$chan_id";
	}
}


# 0: user id
# 1: n
# 2: seek
sub user
{
	my ($user_id, $n, $seek) = @_;
	my $r;

	if (&Conf::rewrite() == 1) {
		$r = "user-$user_id";
		if (defined($n)) {
			$r .= "-$n";
			$r .= "-$seek" if (defined($seek));
		}
	} else {
		$r = "user.pl?user=$user_id";
		if (defined($n)) {
			$r .= "&amp;n=$n";
			$r .= "&amp;seek=$seek" if (defined($seek));
		}
	}

	return $r;
}


# 0: chan
# (1: str)
sub stat
{
	my ($chan, $str) = @_;
	my @param;

	($chan != -1) && push(@param, "chan=$chan");
	(defined($str)) && push(@param, "str=$str");

	return "stat.pl?" . &HTML::esc_param(@param);
}


# 0: set
# (1: go)
sub session($$)
{
	my ($set, $go) = @_;
	my $r;
	$r = "setsession.pl?set=$set";
	if (defined($go)) {
		$r .= "&amp;go=$go";
	}
	return $r;
}


# 0: reset
sub latest($)
{
	my ($reset) = @_;
	if (defined($reset)) {
		return "latest.pl?reset=1";
	} else {
		if (&Conf::rewrite() == 1) {
			return "latest";
		} else {
			return "latest.pl";
		}
	}
}
